unit CompilerCfg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TCompilerCfgForm = class(TForm)
    CompilerView: TListView;
    Done: TButton;
    Remove: TButton;
    Add: TButton;
    Signature: TEdit;
    CmdLine: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure DoneClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CompilerViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure SignatureEnter(Sender: TObject);
	procedure UpdateList;
    procedure SignatureChange(Sender: TObject);
    procedure CmdLineChange(Sender: TObject);
    procedure RemoveClick(Sender: TObject);
    procedure AddClick(Sender: TObject);
  private
    SelIndex: Integer;
  public
    { Public declarations }
  end;

var
  CompilerCfgForm: TCompilerCfgForm;

implementation

uses
	GeneralData;

{$R *.dfm}

procedure TCompilerCfgForm.UpdateList;
var
	L: TListItem;
	i: Integer;
begin
	CompilerView.Items.Clear;
	for i := 0 to Length( CompilerList )-1 do
    begin
    	L := CompilerView.Items.Add;
        L.Caption := CompilerList[i].Sign;
		L.SubItems.Add( CompilerList[i].CmdLine );
    end;

    if CompilerView.Items.Count > 0 then
		CompilerView.Items[0].Selected := True;
end;

procedure TCompilerCfgForm.DoneClick(Sender: TObject);
begin
	SaveConfigs;
    Close;
end;

procedure TCompilerCfgForm.FormShow(Sender: TObject);
begin
	UpdateList;
end;

procedure TCompilerCfgForm.CompilerViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
	if not Selected then
    	Exit;

    SelIndex := Item.Index;
    Signature.Text := CompilerList[ SelIndex ].Sign;
    CmdLine.Text := CompilerList[ SelIndex ].CmdLine;
    Signature.Enabled := True;
    CmdLine.Enabled := True;
end;

procedure TCompilerCfgForm.SignatureEnter(Sender: TObject);
begin
	if CompilerView.SelCount <> 0 then
    	Exit;

    Signature.Text := '';
    CmdLine.Text := '';
    Signature.Enabled := False;
    CmdLine.Enabled := False;
end;

procedure TCompilerCfgForm.SignatureChange(Sender: TObject);
begin
    CompilerList[ SelIndex ].Sign := Signature.Text;
    CompilerView.Items[ SelIndex ].Caption := Signature.Text;
end;

procedure TCompilerCfgForm.CmdLineChange(Sender: TObject);
begin
    CompilerList[ SelIndex ].CmdLine := CmdLine.Text;
    CompilerView.Items[ SelIndex ].SubItems[0] := CmdLine.Text;
end;

procedure TCompilerCfgForm.RemoveClick(Sender: TObject);
var
	i: Integer;
begin
	if CompilerView.SelCount = 0 then
    	Exit;

	for i := SelIndex+1 to Length( CompilerList )-1 do
    	CompilerList[i-1] := CompilerList[i];
    SetLength(CompilerList, Length( CompilerList )-1);
    UpdateList;
end;

procedure TCompilerCfgForm.AddClick(Sender: TObject);
begin
    SetLength(CompilerList, Length(CompilerList)+1);
    CompilerList[ Length(CompilerList)-1 ].Sign := 'new';
    CompilerList[ Length(CompilerList)-1 ].CmdLine := '';
    UpdateList;
end;

end.
