unit Task;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TTaskForm = class(TForm)
    TaskListView: TListView;
    AddTask: TButton;
    RemoveTask: TButton;
    Done: TButton;
    OpenDialog: TOpenDialog;
    procedure AddTaskClick(Sender: TObject);
    procedure RemoveTaskClick(Sender: TObject);
    procedure DoneClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
	procedure RedrawTasks;
  end;

var
  TaskForm: TTaskForm;

implementation

uses
	GeneralData;

{$R *.dfm}

procedure TTaskForm.RedrawTasks;
var
	i: Integer;
    p: TListItem;
begin
	TaskListView.Items.Clear;
	for i := 0 to Length( TaskList )-1 do
    begin
    	p := TaskListView.Items.Add;
        p.Caption := TaskList[i].Name;
        p.SubItems.Add(TaskList[i].Folder);
    end;
end;

procedure TTaskForm.AddTaskClick(Sender: TObject);
var
	S, TaskFolder, TaskName: String;
begin
    if not OpenDialog.Execute then
    	exit;

    { Parse out Folder and TaskName }
    S := OpenDialog.FileName;
    TaskFolder := '';
    while pos('\', S) <> 0 do
    begin
    	TaskFolder := TaskFolder + copy(S, 1, pos('\', S));
        Delete(S, 1, pos('\', S));
    end;
    TaskName := TaskFolder;
    Delete(TaskName, Length(TaskName), 1);
    TaskName := GetName( TaskName );

    { Add task }
    if GeneralData.AddTask(TaskName, TaskFolder) then
    begin
        SaveConfigs;
    	RedrawTasks;
    end;
end;

procedure TTaskForm.RemoveTaskClick(Sender: TObject);
var
	Query: String;
    i: Integer;
begin
	if TaskListView.SelCount = 0 then
    	Exit; { Nothing selected }

    i := TaskListView.Selected.Index;
	Query := '     ' + TaskList[i].Name +
             ' [' + TaskList[i].Folder + ']?';
	if MessageBox(Handle, PChar(Query), PChar('ϳ '),
    		MB_YESNO OR MB_ICONQUESTION OR MB_DEFBUTTON2) = IDYES then
            begin
			    DeleteTask(TaskList[i].Name);
                SaveConfigs;
                RedrawTasks;
            end;
end;

procedure TTaskForm.DoneClick(Sender: TObject);
begin
	Close;
end;

procedure TTaskForm.FormShow(Sender: TObject);
begin
    RedrawTasks;
end;

end.
