#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <algorithm>

using namespace std;

const int MaxS = 512;

int max_score, real_answer;
FILE *fIn, *fOut, *fAns;

int S, C;
int X[MaxS], Y[MaxS];

int claimed_res;
int perm[MaxS], sorted_perm[MaxS];

int main(int argc, char** argv)
{
	if (argc < 2) {
		printf("usage: %s <max_score> <input> <output> <ans>\n", argv[0]);
		return 0;
	}

	freopen("report", "wt", stdout);
	sscanf(argv[1], "%d", &max_score);
	fIn = fopen(argv[2], "r");
	fOut = fopen(argv[3], "r");
	fAns = fopen(argv[4], "r");


	try {

		fscanf(fAns, "%d", &real_answer);

		if(fscanf(fIn, "%d %d", &S, &C) == EOF) {
			printf(" 0 -      (1)");
			return 0;
		}
		for (int i = 0; i < C; i++) {

			if(fscanf(fIn, "%d %d", &X[i], &Y[i]) == EOF) {
				printf(" 0 -      (2)");
				return 0;
			}
			X[i]--;
			Y[i]--;
		}

		if(fscanf(fOut, "%d", &claimed_res) == EOF) {
			printf(" 0 -      (1)");
			return 0;
		}

		for (int i = 0; i < S; i++) {
			int server;
			if(fscanf(fOut, "%d", &server) == EOF) {
				printf(" 0 -      (2)");
				return 0;
			}
			if(server < 1 || server > S) {
				printf(" 0 -      (3)");
				return 0;
			}
			perm[server-1] = i;
		}

		copy(perm, perm+S, sorted_perm);
		sort(sorted_perm, sorted_perm+S);
		for (int i = 0; i < S; i++)
			if (sorted_perm[i] != i) {
				printf(" 0 -  \n");
				return 0;
			}

			int actual_res = 0;
			for (int i = 0; i < C; i++)
				actual_res += abs( perm[X[i]] - perm[Y[i]] );

			if (actual_res != claimed_res) {
				printf(" 0 - ֳ     %d,   %d.\n", claimed_res, actual_res);
				return 0;
			}

			if (real_answer != actual_res) {
				printf(" 0 -   '.  %d,   %d.\n", actual_res, real_answer);
				return 0;
			}
			if (real_answer > actual_res) {
				printf("99 - ...");
			}

			printf("%02d -  '.\n", max_score);


	} catch (exception e) {
		printf(" 0 -  ");
	}
	return 0;
}

