#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <iostream>
#include <queue>
#include <list>
#include <map>
#include <numeric>
#include <set>
#include <sstream>
#include <string>
#include <vector>
#include <fstream>
using namespace std;
#define VAR(a,b) __typeof(b) a=(b)
#define FOR(i,a,b) for (int _n(b), i(a); i < _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;--i)
#define FOREACH(it,c) for(VAR(it,(c).begin());it!=(c).end();++it)
#define REP(i,n) FOR(i,0,n)
#define ALL(c) (c).begin(), (c).end()
#define SORT(c) sort(ALL(c))
#define REVERSE(c) reverse(ALL(c))
#define UNIQUE(c) SORT(c),(c).resize(unique(ALL(c))-(c).begin())
#define INF 1000000000
#define X first
#define Y second
#define pb push_back
#define SZ(c) (c).size()
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<int> VB;
typedef vector<PII> VPII;
typedef vector<VI> VVI;
typedef vector<VB> VVB;

VVB rotate (const VVB& a)
{
    if (!a.size())
        return VVB();
    int n = a.size();
    int m = a[0].size();

    VVB res (m, VB(n));

    REP (i, n)
        REP (j, m)
            res[m-j-1][i] = a[i][j];

    return res;
}

vector <VVB> figures;

void initFigures()
{
    //  *
    // ***

    VVB f1(2, VB (3));
    f1[0][0] = f1[0][1] = f1[0][2] = f1[1][1] = true;

    // *
    // ***

    VVB f2(2, VB (3));
    f2[0][0] = f2[0][1] = f2[0][2] = f2[1][0] = true;

    //   *
    // ***

    VVB f3(2, VB (3));
    f3[0][0] = f3[0][1] = f3[0][2] = f3[1][2] = true;

    // **
    // **

    VVB f4(2, VB (2));
    f4[0][0] = f4[0][1] = f4[1][0] = f4[1][1] = true;

    // *
    // *
    // *
    // *

    VVB f5(4, VB (1));
    f5[0][0] = f5[1][0] = f5[2][0] = f5[3][0] = true;

    // **
    //  **

    VVB f6(2, VB (3));
    f6[0][1] = f6[0][2] = f6[1][0] = f6[1][1] = true;

    //  **
    // **

    VVB f7(2, VB (3));
    f7[0][0] = f7[0][1] = f7[1][1] = f7[1][2] = true;

    figures.pb(f1);
    figures.pb(f2);
    figures.pb(f3);
    figures.pb(f4);
    figures.pb(f5);
    figures.pb(f6);
    figures.pb(f7);
}

VVB a;

bool getA(int x, int y)
{
    return (x < 0) || (y < 0) || (y > 9) || (x < a.size () && a[x][y]);
}

bool canPut(const VVB& f, int x, int y)
{
    REP (i, f.size ())
        REP (j, f[i].size ())
            if (f[i][j] && getA(x+i, y+j))
                return false;
    return true;
}

bool canStop(const VVB& f, int x, int y)
{
    REP (i, f.size ())
        REP (j, f[i].size ())
            if (f[i][j] && getA(x+i-1, y+j))
                return true;
    return false;
}

VPII getPositions(const VVB& f)
{
    VPII res;

    VB prev(10, true);

    FORD (i, a.size(), 0)
    {
        VB can(10, false);
        VB cur(10, false);

        REP (j, 10)
        {
            can[j] = canPut(f, i, j);
            cur[j] = can[j] && prev[j];
        }

        REP (j, 9)
            if (cur[j] && can[j+1])
                cur[j+1] = true;

        FORD (j, 9, 1)
            if (cur[j] && can[j-1])
                cur[j-1] = true;

        REP (j, 10)
            if (cur[j] && canStop(f, i, j))
                res.pb(PII(i, j));

        if (cur == VB(10, false))
            break;

        swap(cur, prev);
    }

    return res;
}

void doPut(const VVB& f, int x, int y)
{
    while (a.size() < x+f.size())
        a.pb(VB(10));

    REP (i, f.size())
        REP (j, f[i].size())
            if (f[i][j])
                a[i+x][j+y] = true;
}

void output()
{
    FORD(i, a.size()-1, 0)
    {
        REP (j, 10)
            cout << (int)a[i][j];
        cout << endl;
    }
    cout << endl;
}

void output(const VVB& f)
{
    FORD(i, f.size()-1, 0)
    {
        REP (j, f[i].size())
            cout << (int)f[i][j];
        cout << endl;
    }
    cout << endl;
}

int getScore()
{
    int r = a.size();

    REP (i, a.size())
    {
        bool ok = true;
        REP (j, 10)
            if (!a[i][j])
            {
                ok = false;
                break;
            }

        if (ok)
            r--;
    }
    return r;
}

void wrongSolution (string error, int figureNum)
{
    cout << 0;
    cout << " - " <<error << "  i " << figureNum+1 << endl;
    exit(0);
}

int readNum(int figureNum)
{
    string s;
    if (! (cin >> s) )
        wrongSolution("  ii ", figureNum);
    if (s.size() > 9)
        wrongSolution("  ", figureNum);

    REP (i, s.size())
        if (s[i]<'0' || s[i]>'9')
            wrongSolution("  ", figureNum);

    int x;
    sscanf (s.c_str(), "%d", &x);

    return x;
}

int main(int argc, char** argv)
{
    freopen ("report", "w", stdout);

    VI best_scores;
    // get best scores
    ifstream best_scores_file(argv[1]);
    int x;
    while (best_scores_file >> x)
        best_scores.pb (x);
    best_scores_file.close();

    // get test score
    int test_score;
    sscanf (argv[2], "%d", &test_score);

    int test_number;
    // get test number
    ifstream test_number_file(argv[5]);
    test_number_file >> test_number;
    test_number_file.close();

    freopen(argv[3], "r", stdin);

    initFigures();

    int n;

    cin >> n;

    VI ff(n);
    REP (i, n)
        cin >> ff[i];

    freopen(argv[4], "r", stdin);

    REP (i, n)
    {
        int rot = readNum(i);
        int x = readNum(i);
        int y = readNum(i);

        if (rot != 0 && rot != 90 && rot != 180 && rot != 270)
            wrongSolution ("  ", i);

        VVB f = figures[ff[i]-1];

        REP (j, rot/90)
            f = rotate(f);

        VPII pos = getPositions(f);

        bool ok = false;
        REP (j, pos.size())
            if (pos[j] == PII(y, x))
            {
                ok = true;
                break;
            }

        if (!ok)
            wrongSolution("   i ii", i);

        doPut(f, y, x);
    }

    best_scores[test_number-1] = min (best_scores[test_number-1], getScore());

    int score = getScore()+1;
    int best_score = best_scores[test_number-1]+1;

    cout << (int)round((0.2 + 0.8*best_score/score)*test_score) << " -  " << endl;

    freopen (argv[1], "w", stdout);
    REP (i, best_scores.size())
        cout << best_scores[i]  << endl;

	return 0;
}
