unit main;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	ExtCtrls, ComCtrls, StdCtrls, Menus, XPMan, ShellAPI, ShlObj, Dialogs;

type
	TMainForm = class(TForm)
    MainMenu: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    XPManifest: TXPManifest;
    UpdateTimer: TTimer;
    ContestantView: TListView;
    PopupMenu: TPopupMenu;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    SaveDialog: TSaveDialog;
    N8: TMenuItem;
    N9: TMenuItem;
    procedure UpdateTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N9Click(Sender: TObject);

	procedure UpdateContestantLine(i: Integer);
    procedure ContestantViewDblClick(Sender: TObject);
    procedure N5Click(Sender: TObject);
    
	private
		procedure UpdateContestantView;
	public
		{ Public declarations }
	end;

var
	MainForm: TMainForm;

implementation

uses
	GeneralData, Grade, Task, CompilerCfg, DetailedInfo;

{$R *.dfm}

procedure TMainForm.UpdateContestantLine(i: Integer);
var
	j: Integer;
    Item: TListItem;
begin
	Item := ContestantView.Items[i];
    with ContestantList[i] do
    begin
        Item.Caption := Display;
        Item.SubItems.Clear;
        Item.SubItems.Add( GetFolder );
        for j := 0 to Length( TaskList ) - 1 do
            Item.SubItems.Add( GetTaskRes(TaskList[j].Name) );
        Item.SubItems.Add( IntToStr( GetTotalPoints ) );
    end;
end;

procedure TMainForm.UpdateContestantView;
var
    i: Integer;
begin
	{ Clear }
	ContestantView.Items.Clear;

    { Setup columns }
    while ContestantView.Columns.Count < 3 + Length( TaskList ) do
    	ContestantView.Columns.Add;
    while ContestantView.Columns.Count > 3 + Length( TaskList ) do
    	ContestantView.Columns.Delete( ContestantView.Columns.Count-1 );

    if ContestantView.Columns[0].Width < 200 then
    	ContestantView.Columns[0].Width := 200;
    if ContestantView.Columns[1].Width < 100 then
    	ContestantView.Columns[1].Width := 400;

    ContestantView.Columns[0].Caption := '';
    ContestantView.Columns[1].Caption := ' ';
    for i := 0 to Length( TaskList ) - 1 do
	    ContestantView.Columns[i+2].Caption := TaskList[i].Name;
	ContestantView.Columns[ Length(TaskList)+2 ].Caption := '';

    { Insert contestants into our table }
	for i := 0 to Length( ContestantList ) - 1 do
    begin
    	ContestantView.Items.Add;
    	UpdateContestantLine(i);
    end;
end;

procedure TMainForm.UpdateTimerTimer(Sender: TObject);
var
	i, j, k: Integer;
begin
   	Caption := 'K-Grader';
	if GradeThreadExec then
    	Caption := Caption + ' -  [' +
        	ContestantList[indGrade].Display + ']';

    for i := 0 to Length( UpdateList )-1 do
    begin
    	k := UpdateList[i];
    	for j := 0 to Length( TaskList )-1 do
        	ContestantList[k].LoadTaskRes( TaskList[j].Name );
    	UpdateContestantLine(k);
    end;
    SetLength(UpdateList, 0);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
	LoadConfigs;
end;

procedure TMainForm.N4Click(Sender: TObject);
begin
	TaskForm.ShowModal;
    UpdateContestantView;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
    UpdateContestantView;
end;

procedure TMainForm.N10Click(Sender: TObject);
var
    lpItemID: PItemIDList;
    BrowseInfo: TBrowseInfo;
    DisplayName: array[0..MAX_PATH] of char;
    TempPath: array[0..MAX_PATH] of char;
begin
	FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
    BrowseInfo.hwndOwner := Handle;
	BrowseInfo.pszDisplayName := @DisplayName;
    BrowseInfo.lpszTitle := PChar('Please specify a folder');
    BrowseInfo.ulFlags := BIF_RETURNONLYFSDIRS;

    lpItemID := SHBrowseForFolder(BrowseInfo);
    if lpItemId = NIL then
    	Exit;

  	SHGetPathFromIDList(lpItemID, TempPath);
	GlobalFreePtr(lpItemID);

    LoadWorks( String(TempPath) );
    SaveConfigs;
    UpdateContestantView;
end;

procedure TMainForm.N7Click(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.N2Click(Sender: TObject);
var
	i, j: Integer;
    Job: TJob;
begin
	if ContestantView.SelCount = 0 then
    	ContestantView.SelectAll;

	for i := 0 to ContestantView.Items.Count-1 do
    begin
    	if not ContestantView.Items[i].Selected then
        	Continue;
       	Job.Folder := ContestantView.Items[i].SubItems[0];
        Job.Index := i;

    	for j := 0 to Length( TaskList )-1 do
        	if ContestantList[i].GetTaskRes( TaskList[j].Name ) = UNTESTED then
            begin
            	Job.Task := TaskList[j].Name;
                AddJob(Job);

            end;
    end;
end;

procedure TMainForm.N3Click(Sender: TObject);
var
	i, j: Integer;
    Job: TJob;
begin
	if ContestantView.SelCount = 0 then
    	ContestantView.SelectAll;

	for i := 0 to ContestantView.Items.Count-1 do
    begin
    	if not ContestantView.Items[i].Selected then
        	Continue;
       	Job.Folder := ContestantView.Items[i].SubItems[0];
        Job.Index := i;

    	for j := 0 to Length( TaskList )-1 do
        begin
           	Job.Task := TaskList[j].Name;
            AddJob(Job);
        end;
    end;
end;

procedure TMainForm.N13Click(Sender: TObject);
var
    i, j, k: Integer;
	DelFolders: array of String;
    Question: String;
    Remove: boolean;
begin
	{ Really delete? }
	if ContestantView.SelCount = 0 then
    begin
    	MessageBox(Handle, '   !', NIL, MB_ICONERROR);
        Exit;
    end else
    begin
    	Question := ' ,    ' +
        	IntToStr(ContestantView.SelCount) +
            ' () (   )?';
    	if MessageBox(Handle, PChar(Question), NIL,
        	MB_ICONQUESTION OR MB_YESNO OR MB_DEFBUTTON2) <> IDYES then
            	Exit;
    end;

    { Create list of to be deleted contestants }
	SetLength(DelFolders, ContestantView.SelCount);
    k := 0;
	for i := ContestantView.Items.Count-1 downto 0 do
    	if ContestantView.Items[i].Selected then
        begin
        	DelFolders[k] := ContestantView.Items[i].SubItems[0];
            ContestantView.Items.Delete(i);
            Inc(k);
        end;

    { Remove contestants }
    k := 0;
	for i := 0 to Length( ContestantList )-1 do
    begin
    	Remove := False;
        for j := 0 to Length( DelFolders )-1 do
        	if ContestantList[i].GetFolder = DelFolders[j] then
            begin
            	Remove := True;
                Break;
            end;

        if not Remove then
        begin
        	if i <> k then
            	ContestantList[k] := ContestantList[i];
        	Inc(k);
        end;
    end;

    if Length( ContestantList ) = k then
    	Exit; { Strange :/ }

    SetLength(ContestantList, k);
    SaveConfigs;
end;

procedure TMainForm.N11Click(Sender: TObject);
begin
	if SaveDialog.Execute then
    	ExportResults( SaveDialog.FileName );
end;

procedure TMainForm.N9Click(Sender: TObject);
begin
    CompilerCfgForm.ShowModal;
end;

procedure TMainForm.ContestantViewDblClick(Sender: TObject);
begin
    if ContestantView.SelCount = 0 then
    	Exit;
    DetailedInfoForm.LoadInfo(ContestantView.Selected.Index);
    DetailedInfoForm.ShowModal;
end;

procedure TMainForm.N5Click(Sender: TObject);
begin
	MessageBox(Handle, PChar('  K-Grader  0.1'), 'K-Grader', 0);
end;

end.
